Index: cdr/cdr_odbc.c
===================================================================
RCS file: /usr/cvsroot/asterisk/cdr/cdr_odbc.c,v
retrieving revision 1.23
diff -u -r1.23 cdr_odbc.c
--- cdr/cdr_odbc.c	25 Jan 2005 06:10:19 -0000	1.23
+++ cdr/cdr_odbc.c	3 Feb 2005 10:50:45 -0000
@@ -39,6 +39,7 @@
 static char *dsn = NULL, *username = NULL, *password = NULL, *table = NULL;
 static int dsn_alloc = 0, username_alloc = 0, password_alloc = 0, table_alloc = 0;
 static int loguniqueid = 0;
+static int gmtime = 0;
 static int dispositionstring = 0;
 static int connected = 0;
 
@@ -61,7 +62,10 @@
 	int res = 0;
 	struct tm tm;
 
-	localtime_r(&cdr->start.tv_sec,&tm);
+	if (gmtime) 
+		gmtime_r(&cdr->start.tv_sec,&tm);
+	else
+		localtime_r(&cdr->start.tv_sec,&tm);
 
 	ast_mutex_lock(&odbc_lock);
 	strftime(timestr, sizeof(timestr), DATE_FORMAT, &tm);
@@ -215,6 +219,7 @@
 		table_alloc = 0;
 	}
 	loguniqueid = 0;
+	gmtime = 0;
 	dispositionstring = 0;
 
 	ast_cdr_unregister(name);
@@ -313,6 +318,19 @@
 		ast_log(LOG_WARNING,"cdr_odbc: Not logging uniqueid\n");
 		loguniqueid = 0;
 	}
+
+        tmp = ast_variable_retrieve(cfg,"global","gmtime");
+        if (tmp) {
+                gmtime = ast_true(tmp);
+                if (gmtime) {
+                        ast_log(LOG_NOTICE,"cdr_odbc: Logging in GMT\n");
+                } else {
+                        ast_log(LOG_ERROR,"cdr_odbc: Not logging in GMT\n");
+                }
+        } else {
+                ast_log(LOG_WARNING,"cdr_odbc: Not logging in GMT\n");
+                gmtime = 0;
+        }
 
 	tmp = ast_variable_retrieve(cfg,"global","table");
 	if (tmp) {
